/*
    This Software (C) Copyright David Goodwin, 2007, 2008.
    
     This is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this software; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * LTSTest.java
 * JUnit based tests for LTS class
 *
 * Created on 24 July 2007, 22:26
 */

package assignment;

import junit.framework.*;
import java.io.*;
import java.lang.*;
import java.util.*;

/**
 *
 * @author David
 */
public class LTSTest extends TestCase {
    
    public LTSTest(String testName) {
        super(testName);
    }

    /** Create the files required for the unit tests
     */
    protected void setUp() throws Exception {
        /* Ok, this function is really nasty. It produces a great big pile o files
         * that are used by tests. 
         */
        
        FileOutputStream fout;		

        /***********************
         * Create LTS-test-file-1.txt which is to test:
         *  - load
         *  - equals
         *  - getFileName
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-1.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SB\nSB/a/n1\nn1/b/n2");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        
        /***********************
         * Create LTS-test-file-2.txt which is to test:
         *  - Composition
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-2.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SC\nSC");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-3.txt which is to test:
         *  - Composition
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-3.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("(SB,SC)\n(SB,SC)/a/(n1,SC)\n(n1,SC)/b/(n2,SC)");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-6.txt which is to test:
         *  - Composition (pass 2)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-6.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SB\nSB/a/n1\nn1/b/n2");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-7.txt which is to test:
         *  - Composition (pass 2)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-7.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SC\nSC/x/m1");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        /***********************
         * Create LTS-test-file-8.txt which is to test:
         *  - Composition (pass 2)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-8.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("(SB,SC)");
            ps.println ("(SB,SC)/a/(n1,SC)");
            ps.println ("(n1,SC)/b/(n2,SC)");
            ps.println ("(SB,m1)/a/(n1,m1)");
            ps.println ("(n1,m1)/b/(n2,m1)");
            ps.println ("(SB,SC)/x/(SB,m1)");
            ps.println ("(n1,SC)/x/(n1,m1)");
            ps.println ("(n2,SC)/x/(n2,m1)");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-9.txt which is to test:
         *  - Composition (pass 3)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-9.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SB\nSB/a/n1\nn1/b/n2");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        /***********************
         * Create LTS-test-file-10.txt which is to test:
         *  - Composition (pass 3)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-10.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SC\nSC/x/m1\nm1/y/k1");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        /***********************
         * Create LTS-test-file-11.txt which is to test:
         *  - Composition (pass 3)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-11.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("(SB,SC)");
            ps.println ("(SB,SC)/a/(n1,SC)");
            ps.println ("(n1,SC)/b/(n2,SC)");
            ps.println ("(SB,m1)/a/(n1,m1)");
            ps.println ("(n1,m1)/b/(n2,m1)");
            ps.println ("(SB,k1)/a/(n1,k1)");
            ps.println ("(n1,k1)/b/(n2,k1)");
            ps.println ("(SB,SC)/x/(SB,m1)");
            ps.println ("(SB,m1)/y/(SB,k1)");
            ps.println ("(n1,SC)/x/(n1,m1)");
            ps.println ("(n1,m1)/y/(n1,k1)");
            ps.println ("(n2,SC)/x/(n2,m1)");
            ps.println ("(n2,m1)/y/(n2,k1)");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-12.txt which is to test:
         *  - Composition (pass 4)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-12.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SB\nSB/a/n1\nn1/b/n2");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        /***********************
         * Create LTS-test-file-13.txt which is to test:
         *  - Composition (pass 4)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-13.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("SC\nSC/a/m1\nm1/y/k1");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        /***********************
         * Create LTS-test-file-14.txt which is to test:
         *  - Composition (pass 4)
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-14.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("(SB,SC)");
            ps.println ("(SB,m1)/y/(SB,k1)");
            ps.println ("(n1,SC)/b/(n2,SC)");
            ps.println ("(SB,SC)/a/(n1,m1)");
            ps.println ("(n1,m1)/y/(n1,k1)");
            ps.println ("(n1,m1)/b/(n2,m1)");
            ps.println ("(n1,k1)/b/(n2,k1)");
            ps.println ("(n2,m1)/y/(n2,k1)");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-15.txt which is to test:
         *  - Parallel reach
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-15.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println ("(SB,SC)");
            //ps.println ("(SB,m1)/y/(SB,k1)");
            //ps.println ("(n1,SC)/b/(n2,SC)");
            ps.println ("(SB,SC)/a/(n1,m1)");
            ps.println ("(n1,m1)/y/(n1,k1)");
            ps.println ("(n1,m1)/b/(n2,m1)");
            ps.println ("(n1,k1)/b/(n2,k1)");
            ps.println ("(n2,m1)/y/(n2,k1)");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-16.txt which is to test:
         *  - Bisimulation
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-16.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("SZ");
            ps.println("SZ/a/n1");
            ps.println("n1/d/k1");
            ps.println("k1/y/k2");
            ps.println("n1/b/n2");
            ps.println("n2/y/k2");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-17.txt which is to test:
         *  - Bisimulation
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-17.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("SZ");
            ps.println("SZ/a/n1");
            ps.println("n1/d/k1");
            ps.println("k1/y/k2");
            ps.println("n1/b/n2");
            ps.println("n2/y/k2");
            ps.println("k1/x/SZ");
            ps.println("n2/x/SZ");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-18.txt which is to test:
         *  - Bisimulation coloring 1
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-18.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("SB");
            ps.println("SB/a/m1");
            ps.println("m1/a/m2");
            ps.println("m2/a/SB");
            ps.println("SB/a/n1");
            ps.println("n1/a/n2");
            ps.println("n2/a/n3");
            ps.println("n3/a/n4");
            ps.println("n4/a/SB");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }

        /***********************
         * Create LTS-test-file-19.txt which is to test:
         *  - Bisimulation coloring 2
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-19.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("SB");
            ps.println("SB/a/m1");
            ps.println("m1/a/m2");
            ps.println("m2/a/m3");
            ps.println("m3/b/m4");
            ps.println("SB/a/n1");
            ps.println("n1/a/n2");
            ps.println("n2/a/n3");
            ps.println("n3/a/n4");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }
        
        /***********************
         * Create LTS-test-file-20.txt which is to test:
         *  - that it fails to load an unquoted space
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-20.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("test abc");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }     
        /***********************
         * Create LTS-test-file-21.txt which is to test:
         *  - that it fails to load an unquoted pipe
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-21.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("test|abc");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }     
        /***********************
         * Create LTS-test-file-22.txt which is to test:
         *  - that it fails to load an unquoted minus symbol
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-22.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("test-abc");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }              
        /***********************
         * Create LTS-test-file-23.txt which is to test:
         *  - that it fails to load an unquoted equals symbol
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-23.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("test=abc");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }              
        
        
        /***********************
         * Create LTS-test-file-24.txt which is to test:
         *  - that it is able to load a quoted space
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-24.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("\"test abc\"");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }     
        /***********************
         * Create LTS-test-file-25.txt which is to test:
         *  - that it is able to load a quoted pipe
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-25.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("\"test|abc\"");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }     
        /***********************
         * Create LTS-test-file-26.txt which is to test:
         *  - that it is able to load a quoted minus symbol
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-26.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("\"test-abc\"");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }              
        /***********************
         * Create LTS-test-file-27.txt which is to test:
         *  - that it is able to load a quoted equals symbol
         */
        try {
            fout = new FileOutputStream ("LTS-test-file-27.txt");
            PrintStream ps = new PrintStream(fout);
            ps.println("\"test=abc\"");
            fout.close();		
        }
        catch (IOException e) {
            System.err.println ("Unable to write to file");
            System.exit(-1);
        }                      
    }

    /** Remove all files created by the setUp() function
     */
    protected void tearDown() throws Exception {
        // Delete files we created.
        new File("LTS-test-file-1.txt").delete();   // (precreated)
        new File("LTS-test-file-2.txt").delete();   // (precreated)
        new File("LTS-test-file-3.txt").delete();   // (precreated)
        new File("LTS-test-file-4.txt").delete();   // (created by testGetFileName)
        new File("LTS-test-file-5.txt").delete();   // (created by testSave)
        
        // Files for Compose Pass 2:
        new File("LTS-test-file-6.txt").delete();
        new File("LTS-test-file-7.txt").delete();
        new File("LTS-test-file-8.txt").delete();
        
        // Files for Compose Pass 3:
        new File("LTS-test-file-9.txt").delete();
        new File("LTS-test-file-10.txt").delete();
        new File("LTS-test-file-11.txt").delete();

        // Files for Compose Pass 4:
        new File("LTS-test-file-12.txt").delete();
        new File("LTS-test-file-13.txt").delete();
        new File("LTS-test-file-14.txt").delete();
        
        // Files for parallel reach compose (also used by compose pass 4)
        new File("LTS-test-file-15.txt").delete();
        
        // Bisimulation test files:
        new File("LTS-test-file-16.txt").delete();
        new File("LTS-test-file-17.txt").delete();
        
        // Coloring test files:
        new File("LTS-test-file-18.txt").delete();
        new File("LTS-test-file-19.txt").delete();

        // Quoting test files:
        new File("LTS-test-file-20.txt").delete();
        new File("LTS-test-file-21.txt").delete();        
        new File("LTS-test-file-22.txt").delete();
        new File("LTS-test-file-23.txt").delete();
        new File("LTS-test-file-24.txt").delete();
        new File("LTS-test-file-25.txt").delete();        
        new File("LTS-test-file-26.txt").delete();
        new File("LTS-test-file-27.txt").delete();        
        
    }

    /**
     * Test of load method, of class LTS.
     */
    public void testLoad() {
        System.out.println("load");
        LTS result = null;
        String filename = "LTS-test-file-1.txt";
        
        try {
            result = LTS.load(filename);
        }
        catch (Exception e) {
            fail ("Exception");
        }
        
        // Ok, the LTS should contain SB\nSB/a/n1\nn1/b/n2
        
        assertEquals("SB",result.getStartNode().getName());
        
        LTSTransition t1 = new LTSTransition(new LTSNode("SB"),new LTSNode("n1"),"a");
        LTSTransition t2 = new LTSTransition(new LTSNode("n1"),new LTSNode("n2"),"b");
        
        assertEquals(true,result.transitionExists(t1));
        assertEquals(true,result.transitionExists(t2));
        
        
        /* Check that unquoted spaces, minus symbols, equals and pipes cause
         *the load to fail.
         */
        try {
            assertNull(LTS.load("LTS-test-file-20.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }
        try {
            assertNull(LTS.load("LTS-test-file-21.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }        
        try {
            assertNull(LTS.load("LTS-test-file-22.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }        
        try {
            assertNull(LTS.load("LTS-test-file-23.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }   
        
        
        /* Check that quoted spaces, minus symbols, equals and pipes allow
         * the load to succeed.
         */
        try {
            assertNotNull(LTS.load("LTS-test-file-24.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }
        try {
            assertNotNull(LTS.load("LTS-test-file-25.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }        
        try {
            assertNotNull(LTS.load("LTS-test-file-26.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }        
        try {
            assertNotNull(LTS.load("LTS-test-file-27.txt"));
        }
        catch (Exception e) {
            fail("Exception");
        }           
    }

    /**
     * Test of save method, of class LTS.
     */
    public void testSave() {
        System.out.println("save");
        
        String filename = "LTS-test-file-5.txt";
        LTS instance = null;
        try {
            instance = LTS.load("LTS-test-file-1.txt");
        }
        catch (Exception e)  {
            fail ("Exception");
        }
        
        try {
        instance.save(filename);
        } catch(Exception e) {fail ("Exception");}
        
        // Ok, the file is now saved. Time to load it to ensure it was saved correctly.
        FileInputStream fin;		
        try
        {
            fin = new FileInputStream ("LTS-test-file-5.txt");
            BufferedReader breader = new BufferedReader(new InputStreamReader(fin));            
            // File should contain SB\nSB/a/n1\nn1/b/n2
            
            if (!breader.readLine().equals("SB")) 
                fail("Expected: Start node");
            
            if (!breader.readLine().equals("SB/a/n1"))
                fail("Expected: first transition");
            
            if (!breader.readLine().equals("n1/b/n2"))
                fail("Expected: second transition");
            
            fin.close();		
        }
        catch (IOException e)
        {
               fail("Unable to read from file");
                System.exit(-1);
        }
        instance.addTransition(new LTSTransition(new LTSNode("hello"),null,""));
        try {
        instance.save();
        } catch (Exception e) {fail("Exception");}
                try
        {
            fin = new FileInputStream ("LTS-test-file-5.txt");
            BufferedReader breader = new BufferedReader(new InputStreamReader(fin));            
            // File should contain SB\nSB/a/n1\nn1/b/n2\nhello or somthing similar
            HashSet<String> tmpStrings = new HashSet<String>();
            
            tmpStrings.add(breader.readLine());
            tmpStrings.add(breader.readLine());
            tmpStrings.add(breader.readLine());
            tmpStrings.add(breader.readLine());
            
            
            
            if (!tmpStrings.contains("SB")) 
                fail("Expected: Start node");
            
            if (!tmpStrings.contains("SB/a/n1"))
                fail("Expected: first transition");
            
            if (!tmpStrings.contains("n1/b/n2"))
                fail("Expected: second transition");
            
            if (!tmpStrings.contains("hello"))
                fail("Expected: final transition");
            
            fin.close();		
        }
        catch (IOException e)
        {
               fail("Unable to read from file");
                System.exit(-1);
        }
        
    }

    /**
     * Test of compose method, of class LTS.
     */
    public void testComposePass1() {
        // A very simple compose test. It is the same as the first example one.
        
        System.out.println("compose pass 1");

        LTS theLTS = null;
        LTS lts2 = null;
        LTS instance = null;
        LTS reach_instance = null;
        LTS whatItShouldBe = null;
        
        try {
            theLTS = LTS.load("LTS-test-file-1.txt");
            lts2 = LTS.load("LTS-test-file-2.txt");
            whatItShouldBe = LTS.load("LTS-test-file-3.txt");
        }
        catch (Exception e) {
            fail("File Load Exception (Load probably fails test)");
        }
        
        instance = LTS.composeA(theLTS, lts2, "");
        reach_instance = LTS.Parallel_ReachA(theLTS, lts2,"");
        
        if (!instance.equals(whatItShouldBe)) {
            System.out.println("Parallel Compose failure");
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
        
        if (!reach_instance.equals(whatItShouldBe)) {
            System.out.println("Parallel Reach failure");
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(reach_instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
        
    }

    /**
     * Test of compose method, of class LTS.
     */
    public void testComposePass2() {
        // A slightly more complex one. Same as the second example.
        
        System.out.println("compose pass 2");

        LTS theLTS = null;
        LTS lts2 = null;
        LTS instance = null;
        LTS reach_instance = null;
        LTS whatItShouldBe = null;
              
        try {
            theLTS = LTS.load("LTS-test-file-6.txt");
            lts2 = LTS.load("LTS-test-file-7.txt");
            whatItShouldBe = LTS.load("LTS-test-file-8.txt");
        }
        catch (Exception e) {
            fail("File Load Exception (Load probably fails test)");
        }
        
        instance = LTS.composeA(theLTS, lts2, "");
        reach_instance = LTS.Parallel_ReachA(theLTS, lts2,"");
        
        if (!instance.equals(whatItShouldBe)) {
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
        
        if (!reach_instance.equals(whatItShouldBe)) {
            System.out.println("Parallel Reach failure");
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(reach_instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
    }
    
    /**
     * Test of compose method, of class LTS.
     */
    public void testComposePass3() {
        // More complex again. Same as the third example.
        
        System.out.println("compose pass 3");

        LTS theLTS = null;
        LTS lts2 = null;
        LTS instance = null;
        LTS reach_instance = null;
        LTS whatItShouldBe = null;
        
        try {
            theLTS = LTS.load("LTS-test-file-9.txt");
            lts2 = LTS.load("LTS-test-file-10.txt");
            whatItShouldBe = LTS.load("LTS-test-file-11.txt");
        }
        catch (Exception e) {
            fail("File Load Exception (Load probably fails test)");
        }
        
        instance = LTS.composeA(theLTS, lts2, "");
        reach_instance = LTS.Parallel_ReachA(theLTS, lts2, "");
        
        if (!instance.equals(whatItShouldBe)) {
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
        
        if (!reach_instance.equals(whatItShouldBe)) {
            System.out.println("Parallel Reach failure");
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(reach_instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
    }
    
    /**
     * Test of compose method, of class LTS.
     */
    public void testComposePass4() {
        
        System.out.println("compose pass 4");

        LTS theLTS = null;
        LTS lts2 = null;
        LTS instance = null;
        LTS whatItShouldBe = null;
        
        try {
            theLTS = LTS.load("LTS-test-file-12.txt");
            lts2 = LTS.load("LTS-test-file-13.txt");
            whatItShouldBe = LTS.load("LTS-test-file-14.txt");
        }
        catch (Exception e) {
            fail("File Load Exception (Load probably fails test)");
        }
        
        HashSet<String> syncSet = new HashSet<String>();
        syncSet.add("a");
        
        instance = LTS.compose(theLTS, lts2, syncSet);
        
        if (!instance.equals(whatItShouldBe)) {
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Composition not correct");
        }
    }
    
    /**
     * Test of compose method, of class LTS.
     */
    public void testReach() {
        
        System.out.println("test parallel reach");

        LTS theLTS = null;
        LTS lts2 = null;
        LTS instance = null;
        LTS whatItShouldBe = null;
        
        try {
            theLTS = LTS.load("LTS-test-file-12.txt");
            lts2 = LTS.load("LTS-test-file-13.txt");
            whatItShouldBe = LTS.load("LTS-test-file-15.txt");
        }
        catch (Exception e) {
            fail("File Load Exception (Load probably fails test)");
        }
        
        HashSet<String> syncSet = new HashSet<String>();
        syncSet.add("a");
        
        instance = LTS.Parallel_Reach(theLTS, lts2, syncSet);
        
        if (!instance.equals(whatItShouldBe)) {
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(instance);
            System.out.println("Dumping correct LTS to system console to assist debugging...");
            LTS.printLTS(whatItShouldBe);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Parallel Reach Composition not correct");
        }
    }
    
    /**
     * Test of equals method, of class LTS.
     */
    public void testEquals() {
        /**************************/
        // @TODO: Add more tests: transition count not equal, start node not equal
        /**************************/
        System.out.println("equals");
        
        /* Load the same file twice - assuming load works both should be equal. */
        LTS theLTS = null;
        LTS instance = null;
        try {
            theLTS = LTS.load("LTS-test-file-1.txt");
            instance = LTS.load("LTS-test-file-1.txt");
        }
        catch (Exception e) {
            fail("Exception");
        }
        boolean expResult = true;
        boolean result = instance.equals(theLTS);
        //assertEquals(expResult, result);
        
        if (expResult != result) 
            fail("LTS instances should be equal: they were loaded from the same file.");
        try {
            theLTS = LTS.load("LTS-test-file-2.txt");
        } catch(Exception e) {
            fail("Exception");
        }
        expResult = false;
        result = instance.equals(theLTS);
        assertEquals(expResult,result);
        
        if (expResult != result)
            fail("LTS instances should not be equal: they were loaded from different files.");

    }
    
    /** Tests the coloring algorithm using figure 3 from assignment 3
     */
    public void testColoring1() {
        System.out.println("Coloring1");
        
        /* All nodes in this LTS should have the same color.
         */
        
        LTS theLTS = null;
        try {
            theLTS = LTS.load("LTS-test-file-18.txt");
        }
        catch (Exception e) {
            fail("Exception");
        }
        
        HashMap<LTSNode, Integer> result = theLTS.colorLTS(theLTS);
        Set<LTSNode> keys = result.keySet();
        Integer first = null;
        for (LTSNode n:keys) {
            if (first==null) first = result.get(n);
            else {
                if (first != result.get(n)) {
                    // They arent all the same. Fail.
                    System.out.println("Coloring failure");
                    System.out.println("The magic 8-ball predicts certain failure..");
                    System.out.println("Dumping LTS to system console to assist debugging...");
                    LTS.printLTS(theLTS);
                    System.out.println("Dumping colors to system console to assist debugging...");
                    System.out.println("Node:       Color:\n---------------------");
                    for (LTSNode m:keys) {
                        System.out.println(m + "   " + result.get(m));
                    }
                    System.out.println("Dump Complete. Prepare to fail...");
                    System.out.println("Error: All nodes should be the same color.");
                    fail("All nodes should be the same color.");
                }
            }
        }
    }
    
    /** Tests the coloring algorithm using figure 2 from assignment 3
     */
    public void testColoring2() {
        System.out.println("Coloring2");
        
        /* Only nodes m4 and n4 should have the same colour
         */
        
        LTS theLTS = null;
        try {
            theLTS = LTS.load("LTS-test-file-19.txt");
        }
        catch (Exception e) {
            fail("Exception");
        }
        
        HashMap<LTSNode, Integer> result = theLTS.colorLTS(theLTS);
        Set<LTSNode> keys = result.keySet();
        Integer m4Color = null;
        Integer n4Color = null;
        HashSet<Integer> colors = new HashSet<Integer>();
        
        for (LTSNode n:keys) {
            if (n.getName().equals("m4"))
                m4Color = result.get(n);
            else if (n.getName().equals("n4"))
                n4Color = result.get(n);
            else {
                Integer color = result.get(n);
                
                for (Integer c:colors)
                    if (c.equals(color)){
                        // Fail: only n4 and m4 are allowed to have the same color
                        System.out.println("Coloring failure");
                        System.out.println("The magic 8-ball predicts certain failure..");
                        System.out.println("Dumping LTS to system console to assist debugging...");
                        LTS.printLTS(theLTS);
                        System.out.println("Dumping colors to system console to assist debugging...");
                        System.out.println("Node:       Color:\n---------------------");
                        for (LTSNode m:keys) {
                            System.out.println(m + "   " + result.get(m));
                        }
                        System.out.println("Dump Complete. Prepare to fail...");
                        System.out.println("Error:Only nodes n4 and m4 are allowed to have the same color");
                        fail("Only nodes n4 and m4 are allowed to have the same color");
                    }
                // If we get this far then it hasnt been encountered yet. Add it.
                colors.add(color);
            }
        }
        
        // Nodes m4 and n4 should have the same color
        if (!m4Color.equals(n4Color)) {
            System.out.println("Coloring failure");
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(theLTS);
            System.out.println("Dumping colors to system console to assist debugging...");
            System.out.println("Node:       Color:\n---------------------");
            for (LTSNode m:keys) {
                System.out.println(m + "   " + result.get(m));
            }
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Nodes m4 and n4 should have the same color");
        }
    }
    
    /** Tests bisimulation
     */
    public void testBisimulation1() {
        System.out.println("Bisimulation1");
        
        LTS theLTS = null;
        LTS instance = null;
        try {
            theLTS = LTS.load("LTS-test-file-1.txt");
            instance = LTS.load("LTS-test-file-1.txt");
        }
        catch (Exception e) {
            fail("Exception");
        }
        boolean expResult = true;
        boolean result = instance.bisimEquals(theLTS, instance);
        
        if (expResult != result) 
            fail("LTS instances are equal - they should be equivalent");
    }
    /** Tests bisimulation
     */    
    public void testBisimulation2() {
        System.out.println("Bisimulation2");
        
        LTS theLTS = null;
        LTS instance = null;
        try {
            theLTS = LTS.load("LTS-test-file-2.txt");
            instance = LTS.load("LTS-test-file-1.txt");
        }
        catch (Exception e) {
            fail("Exception");
        }
        boolean expResult = false;
        boolean result = instance.bisimEquals(theLTS, instance);
        
        if (expResult != result) 
            fail("LTS instances should not be equivalent");
       
    }
    /** Tests bisimulation using figure 1 from assignment 3
     */
    public void testBisimulation3() {
        System.out.println("Bisimulation3");
        
        LTS theLTS = null;
        LTS instance = null;
        try {
            theLTS = LTS.load("LTS-test-file-16.txt");
            instance = LTS.load("LTS-test-file-17.txt");
        }
        catch (Exception e) {
            fail("Exception");
        }
        boolean expResult = true;
        boolean result = instance.bisimEquals(theLTS, instance);
        
        if (expResult != result) 
            fail("LTS should be equivalent");

    }
    
    /** This tests the composition functions using bisimulation equality.
     */
    public void testBisimCompose() {
        LTS theLTS = null;
        LTS lts2 = null;
        LTS instance = null;
        LTS instance2 = null;
        
        try {
            theLTS = LTS.load("LTS-test-file-12.txt");
            lts2 = LTS.load("LTS-test-file-13.txt");
        }
        catch (Exception e) {
            fail("File Load Exception (Load probably fails test)");
        }
        
        HashSet<String> syncSet = new HashSet<String>();
        syncSet.add("a");
        
        instance = LTS.compose(theLTS, lts2, syncSet);
        instance2 = LTS.Parallel_Reach(theLTS, lts2, syncSet);
        
        if (!instance.bisimEquals(instance, instance2)) {
            System.out.println("The magic 8-ball predicts certain failure..");
            System.out.println("Dumping LTS to system console to assist debugging...");
            LTS.printLTS(instance);
            System.out.println("Dump Complete. Prepare to fail...");
            fail("Bisimulation equals failure: The two LTS are equivalent");
        }
    }

    /**
     * Test of getFileName method
     */
    public void testGetFileName() {
        
        /*
         * For this test we need to make sure the file name is stored properly. To do this we must:
         * 1. Load a file
         * 2. Check that the file name is correct
         * 3. Save the file with a different name
         * 4. Check that the file name is still correct.
         */
        
        System.out.println("getFileName");
        LTS instance = null;
        try {
            instance = LTS.load("LTS-test-file-1.txt");
        } catch(Exception e) {
            fail("Exception");
        }
        
        String expResult = "LTS-test-file-1.txt";
        String result = instance.getFileName();
        if (expResult != result)
            fail("Filename was not the same as the file loaded");
        
        try {instance.save("LTS-test-file-4.txt"); }
        catch (Exception e) {fail("Save file exception (Save test probably failed)");}
        result = instance.getFileName();
        expResult = "LTS-test-file-4.txt";
        if (expResult != result)
            fail("Filename was not the same as the saved file");
    }
    
    /**
     * Test the get and set start node methods
     */
    public void testSetGetStartNode() {
        LTSNode temp = new LTSNode("TestNode2000");
        LTS test = new LTS();
        test.setStartNode(temp);
        
        LTSNode result = test.getStartNode();
        if (result.getName() != "TestNode2000")
            fail("Node name was not expected");
    }
    
    /**
     * Test the methods for transition operations: add, exists, remove and remove all
     */
    public void testTransitionOps() {
        LTS theLTS = new LTS();
        
        LTSNode n1 = new LTSNode("node1");
        LTSNode n2 = new LTSNode("node2");
        LTSTransition ltst = new LTSTransition(n1,n2,"transition1");
        LTSTransition ltst2 = new LTSTransition(n2,n1,"transition2");
        LTSTransition ltst3 = new LTSTransition(n2,n1,"transition3");
        
        theLTS.addTransition(ltst);
        theLTS.addTransition(ltst2);
        
        if (!theLTS.transitionExists(ltst))
            fail("Transition was added but doesnt exist");
        
        Collection<LTSTransition> ltsl = theLTS.getTransitions();
        
        if (ltsl.size() != 2)
            fail("two transtitions were added but the list does not contain two.");
        
        if (!ltsl.contains(ltst))
            fail("A transition was added but wasnt in the list");
        
        
        theLTS.removeTransition(ltst);
        
        if(theLTS.transitionExists(ltst))
            fail("Transition was removed but still exists");
        
        // Removing all transitions from the list should not remove them
        // from the list returned by getTransitions()
        theLTS.addTransition(ltst3);
        Collection<LTSTransition> theT = theLTS.getTransitions();
        theLTS.killTransitions();
        if (theLTS.getTransitions().size() != 0)
            fail("All transitions were removed but the list is not empty.");
        
        if (theT.size() == 0)
            fail("Removing all transitions from the LTS removed them from a data structure returned earlier by getTransitions");
        
    }
    
    /**
     * Test the getNodes method
     */
    public void testGetNodes() {
        LTS theLTS = new LTS();
        
        LTSNode n1 = new LTSNode("node1");
        LTSNode n2 = new LTSNode("node2");
        LTSTransition ltst = new LTSTransition(n1,n2,"transition1");
        LTSTransition ltst2 = new LTSTransition(n2,n1,"transition2");
        LTSTransition ltst3 = new LTSTransition(n2,n1,"transition3");
        
        theLTS.addTransition(ltst);
        theLTS.addTransition(ltst2);
        theLTS.addTransition(ltst3);
        
        Collection<LTSNode> nodes = theLTS.getNodes();
        
        if (nodes.size() > 2)
            fail("More than two nodes were returned: There must be duplicates.");
        if (nodes.size() < 2)
            fail("Less than two nodes were returned: There must be one or more missing.");
        
        if (!nodes.contains(n1))
            fail("A node was missing (n1)");
        if (!nodes.contains(n2))
            fail("A node was missing (n2)");
        
        LTSTransition ltt = new LTSTransition(n1,null,"");
        theLTS.addTransition(ltt);
        if (nodes.size() > 2)
            fail("Null nodes should not be returned in the node list");
        
        // Now check that the start node will be returned when it is not in any transitions:
        theLTS = new LTS();
        n1 = new LTSNode("startNode");
        
        nodes = theLTS.getNodes();
        if (theLTS.getNodes().size() != 0)
            fail("There arent any nodes in the LTS, why did it return one?");
        
        theLTS.setStartNode(n1);
        if (theLTS.getNodes().size() != 1)
            fail("There should be only 1 node in the LTS: the start node.");
        
        for (LTSNode n:theLTS.getNodes())
            if (n.getName() != "startNode")
                fail("The node returned was not the start node. The only node present should be the start node.");       
    }
}
